"{ Package: 'jv:calipel/s/tests' }"

TestCase subclass:#BenchmarkRunnerTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'CalipeL-S-Tests'
!

!BenchmarkRunnerTests class methodsFor:'documentation'!

documentation
"
 Replace 'Object', 'NewClass1' and
 the empty string arguments by true values.

 Install (or change) the class by 'accepting',
 either via the menu or the keyboard (usually CMD-A).

 You can also change the category simply by editing
 the categoryString and accepting.

 To be nice to others (and yourself later), do not forget to
 add some documentation; preferably under the classes documentation
 protocol.
 (see the `create documentation stubs' item in the methodList menu;
  switch from instance to class to find this menu item.)

 Notice, that ST/X uses the convention to document the class using
 comment-only class methods (however, ST80 comments are supported and
 can be changed via the class-documentation menu).

"
! !

!BenchmarkRunnerTests class methodsFor:'accessing'!

resources
    ^Array with: BenchmarkTestsLog

    "Created: / 18-07-2013 / 02:42:57 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkRunnerTests methodsFor:'running'!

setUp
    BenchmarkTestsLog current setUp

    "Created: / 18-07-2013 / 02:43:31 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkRunnerTests methodsFor:'tests'!

test_basic_01a

    | runner |

    runner := BenchmarkRunner new.
    runner main: #('BenchmarkTestsSuiteA').

    self assert: runner result outcomes size = 2.

    "Created: / 19-07-2013 / 21:48:40 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 01-08-2013 / 19:10:03 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_basic_01b

    | runner |

    runner := BenchmarkRunner new.
    runner main: #('BenchmarkTestsSuiteA#benchmark2').

    self assert: runner result outcomes size = 1.
    self assert: runner result outcomes anyOne times size = 5.
    self assert: runner result outcomes anyOne times first >= 200.

    "Created: / 19-07-2013 / 21:49:23 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 12-08-2013 / 00:29:58 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_basic_01c

    | runner |

    runner := BenchmarkRunner new.
    runner main: #('-Dmsecs=10' 'BenchmarkTestsSuiteA#benchmark2').

    self assert: runner result outcomes size = 1.
    self assert: runner result outcomes anyOne times size = 5.
    self assert: runner result outcomes anyOne times first < 200.

    "Created: / 19-07-2013 / 21:49:14 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 12-08-2013 / 00:30:02 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_basic_01d

    | runner |

    runner := BenchmarkRunner new.
    runner main: #('-n' '1' '-Dmsecs=10' 'BenchmarkTestsSuiteA#benchmark2').

    self assert: runner result outcomes size = 1.
    self assert: runner result outcomes anyOne times size = 1.
    self assert: runner result outcomes anyOne times first < 200.

    "Created: / 19-07-2013 / 21:49:11 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 12-08-2013 / 00:30:05 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_basic_01e

    | runner |

    runner := BenchmarkRunner new.
    runner main: #('-n' '1' '-Dmsecs=10,250' 'BenchmarkTestsSuiteA#benchmark2').



    self assert: runner result outcomes size = 2.
    self assert: runner result outcomes first times size = 1.
    self assert: runner result outcomes first times first >= runner result outcomes first parameters first value.

    self assert: runner result outcomes second times size = 1.
    self assert: runner result outcomes second times first >= runner result outcomes second parameters first value.

    "Created: / 31-07-2013 / 00:06:35 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 01-08-2013 / 19:16:06 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_basic_02a

    | runner file |

    "How to make a temporary file on Pharo?"
    Smalltalk isSmalltalkX ifFalse:[ ^  self ].

    file := Filename newTemporary.
    [
    file writingFileDo:[:s|
        s nextPutLine: '-Dmsecs=10'.
        s nextPutLine: 'BenchmarkTestsSuiteA#benchmark2'.
    ].
    runner := BenchmarkRunner new.
    runner main: (Array with:'--arguments' with: file pathName).

    self assert: runner result outcomes size = 1.
    self assert: runner result outcomes anElement times size = 5.
    self assert: runner result outcomes anElement times first < 200.

    ] ensure:[
        file remove
    ].

    "Created: / 31-07-2013 / 00:21:21 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 01-08-2013 / 19:14:54 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_basic_03a

    | runner |

    runner := BenchmarkRunner new.
    self should:[
        runner main: #('BenchmarkTestsSuiteC').
    ] raise: BenchmarkExecutionError

    "Created: / 31-07-2013 / 01:15:40 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 01-08-2013 / 19:10:49 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

